/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: _ARM64_FPSR_REGPointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the _ARM64_FPSR_REGPointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=_ARM64_FPSR_REG.class)
public class _ARM64_FPSR_REGPointer extends StructurePointer {

	// NULL
	public static final _ARM64_FPSR_REGPointer NULL = new _ARM64_FPSR_REGPointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected _ARM64_FPSR_REGPointer(long address) {
		super(address);
	}

	public static _ARM64_FPSR_REGPointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static _ARM64_FPSR_REGPointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static _ARM64_FPSR_REGPointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new _ARM64_FPSR_REGPointer(address);
	}

	public _ARM64_FPSR_REGPointer add(long count) {
		return _ARM64_FPSR_REGPointer.cast(address + (_ARM64_FPSR_REG.SIZEOF * count));
	}

	public _ARM64_FPSR_REGPointer add(Scalar count) {
		return add(count.longValue());
	}

	public _ARM64_FPSR_REGPointer addOffset(long offset) {
		return _ARM64_FPSR_REGPointer.cast(address + offset);
	}

	public _ARM64_FPSR_REGPointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public _ARM64_FPSR_REGPointer sub(long count) {
		return _ARM64_FPSR_REGPointer.cast(address - (_ARM64_FPSR_REG.SIZEOF * count));
	}

	public _ARM64_FPSR_REGPointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public _ARM64_FPSR_REGPointer subOffset(long offset) {
		return _ARM64_FPSR_REGPointer.cast(address - offset);
	}

	public _ARM64_FPSR_REGPointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public _ARM64_FPSR_REGPointer untag(long mask) {
		return _ARM64_FPSR_REGPointer.cast(address & ~mask);
	}

	public _ARM64_FPSR_REGPointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return _ARM64_FPSR_REG.SIZEOF;
	}

	// Implementation methods

	// U32:1 C
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_COffset_", declaredType="U32:1")
	public UDATA C() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._C_s_, _ARM64_FPSR_REG._C_b_);
	}

	// U32:1 DZC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_DZCOffset_", declaredType="U32:1")
	public UDATA DZC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._DZC_s_, _ARM64_FPSR_REG._DZC_b_);
	}

	// U32:1 IDC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IDCOffset_", declaredType="U32:1")
	public UDATA IDC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._IDC_s_, _ARM64_FPSR_REG._IDC_b_);
	}

	// U32:1 IOC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IOCOffset_", declaredType="U32:1")
	public UDATA IOC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._IOC_s_, _ARM64_FPSR_REG._IOC_b_);
	}

	// U32:1 IXC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_IXCOffset_", declaredType="U32:1")
	public UDATA IXC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._IXC_s_, _ARM64_FPSR_REG._IXC_b_);
	}

	// U32:1 N
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_NOffset_", declaredType="U32:1")
	public UDATA N() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._N_s_, _ARM64_FPSR_REG._N_b_);
	}

	// U32:1 OFC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_OFCOffset_", declaredType="U32:1")
	public UDATA OFC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._OFC_s_, _ARM64_FPSR_REG._OFC_b_);
	}

	// U32:1 QC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_QCOffset_", declaredType="U32:1")
	public UDATA QC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._QC_s_, _ARM64_FPSR_REG._QC_b_);
	}

	// U32:1 UFC
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_UFCOffset_", declaredType="U32:1")
	public UDATA UFC() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._UFC_s_, _ARM64_FPSR_REG._UFC_b_);
	}

	// U32:1 V
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_VOffset_", declaredType="U32:1")
	public UDATA V() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._V_s_, _ARM64_FPSR_REG._V_b_);
	}

	// U32 Value
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ValueOffset_", declaredType="U32")
	public UDATA Value() throws CorruptDataException {
		return new U32(getIntAtOffset(_ARM64_FPSR_REG._ValueOffset_));
	}

	// U32 Value
	public UDATAPointer ValueEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(_ARM64_FPSR_REG._ValueOffset_));
	}

	// U32:1 Z
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ZOffset_", declaredType="U32:1")
	public UDATA Z() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._Z_s_, _ARM64_FPSR_REG._Z_b_);
	}

	// U32:2 res0_1
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_res0_1Offset_", declaredType="U32:2")
	public UDATA res0_1() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._res0_1_s_, _ARM64_FPSR_REG._res0_1_b_);
	}

	// U32:19 res0_2
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_res0_2Offset_", declaredType="U32:19")
	public UDATA res0_2() throws CorruptDataException {
		return getU32Bitfield(_ARM64_FPSR_REG._res0_2_s_, _ARM64_FPSR_REG._res0_2_b_);
	}

}
